var colors = { 15 : '200, 200, 200', 25 : '200, 0, 0', 45 : '0, 200, 0', 77 : '0, 0, 200'};
var width = 1300;
var temperature_offset;
var multiplier;
function temperatureToYCoordinate(temperature_as_float) {
	var temperature = (temperature_as_float+temperature_offset)*multiplier;
	return 500 - temperature;
}

function drawTemperatureGrid(ctx, lowest, highest) {
	var step = 10;
	var i;
	for (i=0; i <= step; i++) {
		ctx.beginPath();
		ctx.fillStyle = 'rgb(200,200,200)';
		ctx.strokeStyle= 'white';
		ctx.fillText(lowest + (highest-lowest)*i/step+' C', 0, temperatureToYCoordinate(lowest + (highest-lowest)*i/step));
		ctx.moveTo(0, temperatureToYCoordinate(lowest + (highest-lowest)*i/step));
		ctx.lineTo(width, temperatureToYCoordinate(lowest + (highest-lowest)*i/step));
		ctx.stroke();
	}
}

$(document).ready(function(){
		var ctx = $('#graph').get(0).getContext('2d');
		ctx.globalAlpha = 1.0;
		var startTime = new Date(lol[0].time);
		var endTime = new Date(lol[lol.length-1].time);
		var range = endTime - startTime; 	
		var dateStep = parseInt(lol.length/10);
		var lowest = 10000;
		var highest = -10000;
		var sensors = new Array();
		$(lol).each(function(i) {
			var temperature_as_float = parseFloat(this.temperature);
			if (temperature_as_float < lowest) {
			lowest = temperature_as_float;
			}

			if (temperature_as_float > highest) {
			highest = temperature_as_float;
			}
			if (i%dateStep == 0) {
			var time = new Date(this.time);
			var x = (time - startTime)*width / range ;
			ctx.save();
			ctx.fillStyle = 'rgb(200,200,200)';
			ctx.fillText(time.toTimeString().substring(0,5), x, 500);
			ctx.restore();
			}
			});
		if (window.console) {
			console.log("lowest: "+lowest);
			console.log("highest: "+highest);
		}
		temperature_offset = 1 - lowest;
		multiplier = 500 / (highest-lowest+2);
		drawTemperatureGrid(ctx, lowest, highest);
		$(lol).each(function(i) {
				if (!sensors[this.sender]) {
				if (window.console) {
				console.log("new sender: "+this.sender);
				}
				sensors[this.sender]=new Array();
				}
				sensors[this.sender].push(this);
				});
		function getX(reading) {
			var time = new Date(reading.time);
			return (time - startTime)*width / range ;
		}
		function getY(reading) {
			var temperature_as_float = parseFloat(reading.temperature);
			return temperatureToYCoordinate(temperature_as_float);
		}
		$(sensors).each(function() {
				if (this.length) {
				ctx.save();
				ctx.strokeStyle = 'rgb('+colors[this[0].sender]+')';
					ctx.lineWidth= 2;
					ctx.beginPath();
					ctx.moveTo(getX(this[0]),getY(this[0]));
					$(this).each(function() {
						var temperature_as_float = parseFloat(this.temperature);
						var temperature = getY(this);
						var x = getX(this); 
						ctx.lineTo(x, temperature, x,temperature);
						});
					ctx.stroke();
					ctx.restore();
					}
					});
				});

